/*******************************************************************************
* File Name: UART_G_SPI_UART_PVT.h
* Version 1.10
*
* Description:
*  This private file provides constants and parameter values for the
*  SCB Component in SPI and UART modes.
*  Please do not use this file or its content in your project.
*
* Note:
*
********************************************************************************
* Copyright 2013, Cypress Semiconductor Corporation. All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_SCB_SPI_UART_PVT_UART_G_H)
#define CY_SCB_SPI_UART_PVT_UART_G_H

#include "UART_G_SPI_UART.h"


/***************************************
*     Internal Global Vars
***************************************/

#if(UART_G_INTERNAL_RX_SW_BUFFER_CONST)
    extern volatile uint32  UART_G_rxBufferHead;
    extern volatile uint32  UART_G_rxBufferTail;
    extern volatile uint8   UART_G_rxBufferOverflow;
#endif /* (UART_G_INTERNAL_RX_SW_BUFFER_CONST) */

#if(UART_G_INTERNAL_TX_SW_BUFFER_CONST)
    extern volatile uint32  UART_G_txBufferHead;
    extern volatile uint32  UART_G_txBufferTail;
#endif /* (UART_G_INTERNAL_TX_SW_BUFFER_CONST) */

#if(UART_G_INTERNAL_RX_SW_BUFFER)
    extern volatile uint8 UART_G_rxBufferInternal[UART_G_RX_BUFFER_SIZE];
#endif /* (UART_G_INTERNAL_RX_SW_BUFFER) */

#if(UART_G_INTERNAL_TX_SW_BUFFER)
    extern volatile uint8 UART_G_txBufferInternal[UART_G_TX_BUFFER_SIZE];
#endif /* (UART_G_INTERNAL_TX_SW_BUFFER) */


/***************************************
*     Private Function Prototypes
***************************************/

#if(UART_G_SCB_MODE_SPI_CONST_CFG)
    void UART_G_SpiInit(void);
#endif /* (UART_G_SCB_MODE_SPI_CONST_CFG) */

#if(UART_G_SPI_WAKE_ENABLE_CONST)
    void UART_G_SpiSaveConfig(void);
    void UART_G_SpiRestoreConfig(void);
#endif /* (UART_G_SPI_WAKE_ENABLE_CONST) */

#if(UART_G_SCB_MODE_UART_CONST_CFG)
    void UART_G_UartInit(void);
#endif /* (UART_G_SCB_MODE_UART_CONST_CFG) */

#if(UART_G_UART_WAKE_ENABLE_CONST)
    void UART_G_UartSaveConfig(void);
    void UART_G_UartRestoreConfig(void);
#endif /* (UART_G_UART_WAKE_ENABLE_CONST) */

/* Interrupt processing */
#define UART_G_SpiUartEnableIntRx(intSourceMask)  UART_G_SetRxInterruptMode(intSourceMask)
#define UART_G_SpiUartEnableIntTx(intSourceMask)  UART_G_SetTxInterruptMode(intSourceMask)
uint32 UART_G_SpiUartDisableIntRx(void);
uint32 UART_G_SpiUartDisableIntTx(void);

#endif /* (CY_SCB_SPI_UART_PVT_UART_G_H) */


/* [] END OF FILE */
